diff --git a/src/bin/psql/tab-complete.c b/src/bin/psql/tab-complete.c
new file mode 100644
index 8eb9f83..7859d8c
*** a/src/bin/psql/tab-complete.c
--- b/src/bin/psql/tab-complete.c
*************** static const SchemaQuery Query_for_list_
*** 377,383 ****
  	"pg_catalog.pg_class c",
  	/* selcondition */
  	"(c.relkind = 'r' OR (c.relkind = 'v' AND c.relhastriggers AND EXISTS "
! 	"(SELECT 1 FROM pg_catalog.pg_trigger t WHERE t.tgrelid = c.oid AND t.tgtype & (1 << 2) <> 0)))",
  	/* viscondition */
  	"pg_catalog.pg_table_is_visible(c.oid)",
  	/* namespace */
--- 377,384 ----
  	"pg_catalog.pg_class c",
  	/* selcondition */
  	"(c.relkind = 'r' OR (c.relkind = 'v' AND c.relhastriggers AND EXISTS "
! 	"(SELECT 1 FROM pg_catalog.pg_trigger t WHERE t.tgrelid = c.oid AND t.tgtype & (1 << 2) <> 0))"
! 	" OR (c.relkind = 'f' AND (pg_catalog.pg_relation_is_updatable(c.oid, 'f') & (1 << 3) <> 0)))",
  	/* viscondition */
  	"pg_catalog.pg_table_is_visible(c.oid)",
  	/* namespace */
*************** static const SchemaQuery Query_for_list_
*** 393,399 ****
  	"pg_catalog.pg_class c",
  	/* selcondition */
  	"(c.relkind = 'r' OR (c.relkind = 'v' AND c.relhastriggers AND EXISTS "
! 	"(SELECT 1 FROM pg_catalog.pg_trigger t WHERE t.tgrelid = c.oid AND t.tgtype & (1 << 3) <> 0)))",
  	/* viscondition */
  	"pg_catalog.pg_table_is_visible(c.oid)",
  	/* namespace */
--- 394,401 ----
  	"pg_catalog.pg_class c",
  	/* selcondition */
  	"(c.relkind = 'r' OR (c.relkind = 'v' AND c.relhastriggers AND EXISTS "
! 	"(SELECT 1 FROM pg_catalog.pg_trigger t WHERE t.tgrelid = c.oid AND t.tgtype & (1 << 3) <> 0))"
! 	" OR (c.relkind = 'f' AND (pg_catalog.pg_relation_is_updatable(c.oid, 'f') & (1 << 4) <> 0)))",
  	/* viscondition */
  	"pg_catalog.pg_table_is_visible(c.oid)",
  	/* namespace */
*************** static const SchemaQuery Query_for_list_
*** 409,415 ****
  	"pg_catalog.pg_class c",
  	/* selcondition */
  	"(c.relkind = 'r' OR (c.relkind = 'v' AND c.relhastriggers AND EXISTS "
! 	"(SELECT 1 FROM pg_catalog.pg_trigger t WHERE t.tgrelid = c.oid AND t.tgtype & (1 << 4) <> 0)))",
  	/* viscondition */
  	"pg_catalog.pg_table_is_visible(c.oid)",
  	/* namespace */
--- 411,418 ----
  	"pg_catalog.pg_class c",
  	/* selcondition */
  	"(c.relkind = 'r' OR (c.relkind = 'v' AND c.relhastriggers AND EXISTS "
! 	"(SELECT 1 FROM pg_catalog.pg_trigger t WHERE t.tgrelid = c.oid AND t.tgtype & (1 << 4) <> 0))"
! 	" OR (c.relkind = 'f' AND (pg_catalog.pg_relation_is_updatable(c.oid, 'f') & (1 << 2) <> 0)))",
  	/* viscondition */
  	"pg_catalog.pg_table_is_visible(c.oid)",
  	/* namespace */
